{
  open HorsParser        (* The type token is defined in horsParser.mli *)
  exception Eof
}

rule token = parse
  |[' ' '\t']{ token lexbuf }
  |['\n'] {EOL}
  |['0'-'9']+ as lxm { INT(int_of_string lxm) }
  |['a'-'n']|['p'-'z'] as s{ VAR_TERMINAL(s)}
  |['A'-'Z']as t{NONTERMINAL(t)}
  |':'{OF_TYPE}
  |'-'{REWRITES_TO}
  |'.'{BOUNDED_TO}
  |'('{LBRACKET}
  |')'{RBRACKET}
  |'o'{OMICRON}
  |eof {raise Eof}
  
