(* the list of states on the right of each delta rule*)
type q= int list;;
(*each delement is a delta rule*)
type delement= {di:int;dc:char;dq:q};;
type d=delement list;;

(*
* this function prints to the file 'myfile' 
* all the delta rules of the automaton
*)
let rec output_delta myfile de= 
match de with
d1::l-> 
  output_string myfile (string_of_int d1.di);
  output_char myfile d1.dc; 
  output_char myfile '\n';
  output_delta myfile l
|[]->
  output_char myfile '\n';;

(*
* returns the list of delta rules, which is constructed from 'pl'.
* 'pl' will be provided by the parser
*)
let rec get_delta_list pl= 
match pl with
d1::l-> 
  (d1.di, d1.dc, d1.dq):: get_delta_list l
|[]->
  [];;



